void
get_flags(char **argv) {
    for (i32 i = 1; argv[i] != NULL; i++) {
        if (ft_strcmp(argv[i], "--") == 0)
            return;
        if (argv[i][0] == '-') {
            for (i32 j = 1; argv[i][j] != '\0'; j++) {
                if (argv[i][j] == 'l')
                    flags.l = true;
                else if (argv[i][j] == 'a')
                    flags.a = true;
                else if (argv[i][j] == 'R')
                    flags.R = true;
                else if (argv[i][j] == 'r')
                    flags.r = true;
                else if (argv[i][j] == 't')
                    flags.t = true;
                else {
                    flags.error[0] = i;
                    flags.error[1] = j;

                    return ;
                }
            }
        }
    }
}

void
parsing(char **argv, t_list ***files, t_list ***dirs, i32 *max_size, i32 *len, i32 *error) { 
    for (i32 i = 0; argv[i + 1] != NULL; i++) {
        if (ft_strcmp(argv[i + 1], "--") == 0 && !flags.dashdash) {
            flags.dashdash = true;
            continue;
        }
        dir_t *dir = get_directory_files(argv[i + 1]);
        if (dir != NULL) {
            (*len)++;
            if (dir->is_file) {
                *max_size = MAX(ft_get_size(dir->lstat.st_size), *max_size);
                add_sort(*files, dir, true);
            }
            else
                add_sort(*dirs, dir, true);
        }
        else if (errno > 0)
            *error = 2;
    }
    flags.dashdash = false;
}

static void*
free_dir_return_null(dir_t *dir) {
    free(dir->path);
    free(dir->name);
    free(dir);
    return NULL;
}

dir_t *
get_directory_files(char *path) {
    if (!flags.dashdash && path[0] == '-' && ft_strlen(path) != 1)
        return NULL;

    dir_t *dir = ft_calloc(1, sizeof(dir_t));
    if (!dir)
        return NULL;
    dir->path = ft_strdup(path);
    dir->name = ft_strdup(path);
    stat(path, &dir->stat);
    lstat(path, &dir->lstat);
    dir->psswd = getpwuid(dir->stat.st_uid);
    if (!dir->psswd)
        return free_dir_return_null(dir);

    dir->grp = getgrgid(dir->psswd->pw_gid);
    if (!dir->grp)
        return free_dir_return_null(dir);

    if (S_ISLNK(dir->lstat.st_mode)) {
        dir->is_file = true;
        return dir;
    }

    dir->dir = opendir(path);
    if (dir->dir == NULL) {
        if (errno == EACCES) {
            ft_printf_fd(2, "ft_ls: cannot access '%s': Permission denied\n", path);
            dir->is_file = true;
            return dir;
        }
        else if (errno == ENOENT)
            ft_printf_fd(2, "ft_ls: cannot access '%s': No such file or directory\n", path);
        else if (errno == ENOTDIR) {
            dir->is_file = true;
            return dir;
        }  
        return free_dir_return_null(dir);
    }

    return dir;
}
